package junior.core;
import junior.*;
 
public class Atom extends Instruction
{  
   final public Action action;
   public Atom(Action action){ this.action = action; }
   public String toString(){ return PrintInstruction.Action(action); }

   public MicroState rewrite(EnvironmentImpl env){
      action.execute(env);
      return new MicroState(TERM,new Nothing());
   }
  
   public Program copy(){ return new Atom(action); }
}
