package junior.core;
import junior.*;

public class Link extends UnaryInstruction
{  
  final public ObjectWrapper wrapper;

  public Link(ObjectWrapper wrapper, Program body){ super(body); this.wrapper = wrapper; }    
  
  public String toString(){ return PrintInstruction.Link(wrapper,""+body); }

  public MicroState rewrite(EnvironmentImpl env){ 
     return new LinkStatic(wrapper.evaluate(env),body).rewrite(env);    
  }
  
  public Program copy(){ return new Link(wrapper,body.copy()); }
}