package junior.core;
import junior.*;

public class PrintInstruction
{
   static public String Nothing(){ return "nothing"; }
   static public String Stop(){ return "stop"; }
   static public String Action(Action action){ return ""+action; }
   static public String Await(String config){ return "await "+config; }
   static public String Control(String presence, String body){ 
       return "control "+body+" by "+presence; 
   }
   static public String Freezable(String presence, String body){ 
       return "freeze "+body+" on "+presence; 
   }
   static public String Generate(IdentifierWrapper idwrap){ return "generate "+idwrap; }   

   static public String If(BooleanWrapper wrapper, String left, String right){
      return "if "+wrapper+" then "+left+" else "+right+" end";
   }
   static public String Local(String local, String body){ 
      return "event "+local+" in "+body+" end";
   }
   static public String IODecl(IdentifierWrapper wrapper, String local, String body){
      return "inputoutput "+wrapper+" is "+local+" in "+body+" end";
   }
   static public String Link(ObjectWrapper wrapper, String body){ 
      return "link "+wrapper+" in "+body+" end";
   }
   static public String Loop(String body){ return "loop\n"+body+"\nend"; }

   static public String Merge(String left, String right){ 
      return "("+left+" || "+right+")"; 
   }
   static public String Repeat(IntegerWrapper exp, String body){ 
      return "loop {"+exp+"} "+body+" end"; 
   }
   static public String Repeat(int exp, String body){ 
      return "loop {"+exp+"} "+body+" end"; 
   }   
   static public String Seq(String left, String right){ return left+"; "+right; }
   static public String Until(String config, String left, String right){
        return "do\n"+left+"\nuntil "+config+"\nhandle "+right+"\nend"; 
   }
   static public String When(String config, String left, String right){ 
      return "when "+config+" then "+left+" else "+right+" end"; 
   }
   static public String Print(String msg){ return "System.out.print(\""+msg+"\")"; }
}