package junior.core;
import junior.*;

public class Repeat extends UnaryInstruction
{
  final public IntegerWrapper wrapper;
  
  public Repeat(IntegerWrapper wrapper,Program body){ super(body); this.wrapper = wrapper; }
  public String toString(){ return PrintInstruction.Repeat(wrapper,""+body); }

    
  public MicroState rewrite(EnvironmentImpl env){
     return new RepeatStatic(wrapper.evaluate(env),body).rewrite(env); 
  }
  
  public Program copy(){ return new Repeat(wrapper,body.copy()); }
}