package junior.core;
import junior.*;

public class Await extends Instruction
{
  final public Config config;
  
  public Await(Configuration config){ this.config = (Config)config; }
  
  public String toString(){ return PrintInstruction.Await(""+config); }
    
  public MicroState rewrite(EnvironmentImpl env){
      if (config.sat(env)) return new MicroState((env.eoi ? STOP : TERM),new Nothing()); 
      if (config.unsat(env)) return new MicroState(STOP,this); 
      return unknown();
  }
  
  public Program copy(){ return new Await(config.copy()); }
}
