package junior.core;
import junior.Configuration;

abstract public class Config implements Configuration, java.io.Serializable
{
  abstract public boolean fixed(EnvironmentImpl env);
  abstract public boolean eval(EnvironmentImpl env);
  abstract public void reset();
  abstract public Configuration copy();
  
  public boolean sat(EnvironmentImpl env){ return fixed(env) && eval(env); }
  public boolean unsat(EnvironmentImpl env){ return fixed(env) && !eval(env); }
  public boolean equals(Config config){ return getClass() == config.getClass(); }
}
