package junior.core;
import junior.*;

public class Generate extends Instruction
{
  final public IdentifierWrapper idwrap; 
  final public ObjectWrapper objwrap;
  
  public Generate(IdentifierWrapper idwrap, ObjectWrapper objwrap){ 
     this.idwrap = idwrap; this.objwrap = objwrap; 
  }
  
  public String toString(){ return PrintInstruction.Generate(idwrap); }

  public MicroState rewrite(EnvironmentImpl env){
     env.generate(idwrap.evaluate(env),objwrap.evaluate(env));
     return new MicroState(TERM,new Nothing());  
  }
  
  public Program copy(){ return new Generate(idwrap,objwrap); }
}
