package junior.core;
import junior.*;

public class If extends BinaryInstruction
{
  final public BooleanWrapper wrapper;

  public If(BooleanWrapper wrapper,Program thenInst, Program elseInst){ 
     super(thenInst,elseInst); this.wrapper = wrapper;
  } 

  public String toString(){ return PrintInstruction.If(wrapper,""+left,""+right); }
       
  public MicroState rewrite(EnvironmentImpl env){
     return (wrapper.evaluate(env) ? left : right).rewrite(env); 	
  }      
  
  public Program copy(){ return new If(wrapper,left.copy(),right.copy()); }
}
