package junior.core;
import junior.*;

public class Instant extends UnaryInstruction
{   
   public Instant(Program body){ super(body); }
   
   public MicroState rewrite(EnvironmentImpl env){
      MicroState s = body.rewrite(env);
      if (s.flag != SUSP) return new MicroState(s.flag,new Instant(s.term));
      if (env.move) env.move = false; else env.eoi = true; 
      return new Instant(s.term).rewrite(env); 
   }
   
   public Program copy(){ return new Instant(body.copy()); }
}
