package junior.core;
import junior.*;

public class Loop extends UnaryInstruction
{  
   public Loop(Program body){ super(body); }
  
   public String toString(){ return PrintInstruction.Loop(""+body); }

   public MicroState rewrite(EnvironmentImpl env){
      MicroState s = body.rewrite(env);
      if (TERM == s.flag) return new Loop(body).rewrite(env);
      return new MicroState(s.flag,new Seq(s.term,new Loop(body)));
   }
  
   public Program copy(){ return new Loop(body.copy()); }
}
