package junior.core;
import junior.Configuration;

public class Not extends Config 
{
  final public Config config;
  
  public Not(Configuration config){ this.config = (Config)config; }
  public void reset(){ config.reset(); }
  
  public String toString(){ return "not "+config; }
  
  public boolean equals(Config other){ 
     return super.equals(other) && config.equals(((Not)other).config);
  }
  
  public boolean fixed(EnvironmentImpl env){ return config.fixed(env); }
  public boolean eval(EnvironmentImpl env){ return ! config.eval(env); }
  
  public Configuration copy(){ return new Not(config.copy()); }
}
