package junior.core;
import junior.*;

public class Seq extends BinaryInstruction
{  
  public Seq(Program left,Program right){ super(left, right); }
  
  public String toString(){ return PrintInstruction.Seq(""+left,""+right); }
  
  public MicroState rewrite(EnvironmentImpl env){
     MicroState s = left.rewrite(env);
     if (TERM == s.flag) return right.rewrite(env); 
     return new MicroState(s.flag,new Seq(s.term,right));
  }
  
  public Program copy(){ return new Seq(left.copy(),right.copy()); }
}
