package junior.core;
import junior.*;

public class When extends BinaryInstruction
{
  final public Config config;
  
  public When(Configuration config,Program thenInst, Program elseInst){ 
     super(thenInst,elseInst); this.config = (Config)config; 
  }
  public String toString(){ return PrintInstruction.When(""+config,""+left,""+right); }
 
  public MicroState rewrite(EnvironmentImpl env){
     if (config.sat(env)){
	    if (env.eoi) return new MicroState(STOP,left); 
	    else return left.rewrite(env); 
     }
     if (config.unsat(env)){ 
	    if (env.eoi) return new MicroState(STOP,right); 
	    else return right.rewrite(env);  
     }
     return unknown();
  }
  
  public Program copy(){ return new When(config.copy(),left.copy(),right.copy()); }
}
